package com.steerinfo.dil.tmsshiptotalresult.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.dil.tmsshiptotalresult.model.TmsshipTotalResult;
import com.steerinfo.dil.tmsshiptotalresult.service.ITmsshipTotalResultService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;
import java.math.BigDecimal;

/**
 * TmsshipTotalResult RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-12-08 09:04
 * 类描述
 * 修订历史：
 * 日期：2021-12-08
 * 作者：generator
 * 参考：
 * 描述：TmsshipTotalResult RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/tmsshiptotalresults")
public class TmsshipTotalResultController extends BaseRESTfulController {

    @Autowired
    ITmsshipTotalResultService tmsshipTotalResultService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("tmsshiptotalresult:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<TmsshipTotalResult> list = tmsshipTotalResultService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("tmsshiptotalresult:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<TmsshipTotalResult> list = tmsshipTotalResultService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据TmsshipTotalResult对象创建")
    @ApiImplicitParam(name = "tmsshipTotalResult", value = "详细实体tmsshipTotalResult", required = true, dataType = "TmsshipTotalResult")
    //@RequiresPermissions("tmsshiptotalresult:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute TmsshipTotalResult model){
        TmsshipTotalResult tmsshipTotalResult = tmsshipTotalResultService.add(model);
        return success(tmsshipTotalResult);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "Short")
    //@RequiresPermissions("tmsshiptotalresult:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable Short id){
        TmsshipTotalResult tmsshipTotalResult = tmsshipTotalResultService.getById(id);
        return success(tmsshipTotalResult);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的tmsshipTotalResult信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "Short"),
        @ApiImplicitParam(name = "tmsshipTotalResult", value = "详细实体tmsshipTotalResult", required = true, dataType = "TmsshipTotalResult")
    })
    //@RequiresPermissions("tmsshiptotalresult:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable Short id, @RequestBody TmsshipTotalResult model){
        model.setId(id);
        TmsshipTotalResult tmsshipTotalResult = tmsshipTotalResultService.modify(model);
        return success(tmsshipTotalResult);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "Short")
    //@RequiresPermissions("tmsshiptotalresult:delete")
    @DeleteMapping(value = "/{id}")//Short
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<Short> ids = ListUtils.convertList(list);
			  tmsshipTotalResultService.delete(ids);
    	}
      return success();
    }
}
